package harmo.tpexceptions.ex1;

/*
 * Exercise:
 * - Compile this program
 * - What do you notice? Why?
 * - How to solve it?
 * - Do it and compile the program again.
 * */

public class Ex1 {

  public static void main(String[] args) {
    if(args.length!=1) {
      System.err.println("Usage: java harmo.tpexceptions.ex1.Ex1 <number>");
    } else {
      try {
        float result=0;
        result = 1/Float.parseFloat(args[0]);

        /* display the result with 5 significant digits 
         * WARNING: do not use this "quick and dirty" method to round floating
         * numbers in a professional software. Use the appropriate method and
         * library.
         * */
        System.out.println("result = "+ Math.round(result*100000f)/100000f +" (args[0] = "+args[0]+")");
      } catch (RuntimeException ex) { 
        System.err.println("Runtime "+ex); 
      } catch (NumberFormatException ex) {
        System.err.println("NumberFormat "+ex); 
      } catch (IndexOutOfBoundsException ex) {
        System.err.println("Index OoB "+ex); 
      } catch (ArithmeticException ex) { 
        System.err.println("Arithmetic "+ex); 
      }
    }
  }

}
